#include <iostream>
#include <fstream>
#include <string>
#include "../Block.hh"
#include "../Header.hh"

using namespace Header;
using namespace Block;
using std::string;
inline string removeLeadingBlanks(string s)
{
  int i=0;
  while(s[i]==' '){
    i++;
  }
  string newstring;
  for(int j=i;j<s.size();j++) newstring += s[j];
  return newstring;
}

int main()
{
  string surveylist[3]={"S70","PM","bob"};
  string filelist[3]={"data/s70_tape_test_S181_S18101.dat",
		      "data/pttape_test","data/pttape_test"};

  try{
    
    for(int s=0;s<3;s++){
      
      std::cout <<surveylist[s]<<":\n";
      
      DataBlock block(surveylist[s]);
      std::ifstream fin;
      fin.open(filelist[s].c_str(),std::ios::binary);
      block.readHeader(fin);
      int nchan = block.getKeyword<int>(NCHAN);
      std::cout << nchan << " channels\n";
      for(int i=0;i<2;i++){
	float freq = block.getKeyword<float>(FREQ_CHAN1,i);
	std::cout << "Freq #" <<i+1<<" = " << freq << " MHz\n";
      }
      for(int i=0;i<block.Survey().getFieldDimension(COMMENT);i++){
	std::cout << block.getKeyword<std::string>(COMMENT,i)<<"\n";
      }
      for(int i=0;i<block.Survey().getFieldDimension(STATUS);i++){
	std::cout<<"\"" << block.getKeyword<std::string>(STATUS,i)<<"\"\n";
      }
      std::string ra = block.getKeyword<std::string>(RA);
      std::cout << removeLeadingBlanks(ra) << std::endl;
      std::cout << "\n";
    }
  }
  catch(SurveySchema::xBadSurvey bad){
    std::cout << "Survey \"" << bad.getSurvey() << "\" does not exist!\n";
  }

}
