#include <iostream>
#include <sstream>
#include <fitsio.h>
#include "../Utils.hh"
#include <vector>
#include <string>

int main()
{

//   std::vector<bool> bin(8,false);
//   bin[1] = bin[2] = bin[7] = true;
//   for(int i=0;i<8;i++) std::cout << bin[i];
//   std::cout << " --> " << binaryToString(bin) << std::endl;

  float version;
  fits_get_version(&version);
  std::cerr << "Version no." << version << std::endl;

  fitsfile *fptr;
  int status = 0;
  char *template_file = (char *)getPSRFITSdefn().c_str();
  std::cerr << "opening with template...";
  //  fits_create_template(&fptr, "!test.fits", getPSRFITSdefn().c_str(),&status);
  //  fits_create_template(&fptr, "!test.fits", "simpletemplate.fits",&status);
//   fits_create_template(&fptr,"!test.fits","combinedtemplate.fits",&status);
  fits_create_template(&fptr,"!test.fits","psrheaderSimple.txt",&status);
  if(status) fits_report_error(stderr, status);
  std::cerr << "done.\n";


  std::cerr << "moving to subint hdu...";
  status = 0;
  fits_movnam_hdu(fptr, ANY_HDU, "subint", 0, &status);
  if(status) fits_report_error(stderr, status);
  std::cerr << "done.\n";

  std::cerr << "fixing format...";
  std::stringstream ss;
  int colnum;
  status=0;
  fits_get_colnum(fptr, CASEINSEN, "DATA", &colnum, &status);
  if(status) fits_report_error(stderr, status);
//   ss << "TFORM" << colnum;
//   char *tform = (char*)ss.str().c_str();
  char cval[9];
  strcpy(cval,"2B");
//   status=0;
//   std::cerr << " changing " << tform << " to \"" << cval <<"\"...";
  fits_update_key(fptr, TSTRING, "TFORM19", cval, NULL, &status);
  if(status) fits_report_error(stderr, status);
//   status=0;
//   fits_compress_heap(fptr,&status);
//   if(status) fits_report_error(stderr, status);
  std::cerr << "done.\n";

  std::cerr << "closing...";
  status = 0;
  fits_close_file(fptr, &status);
  if (status){
    fits_report_error(stderr, status);
  }
  std::cerr << "done.\n";

}
