#include <iostream>
#include <fitsio.h>
#include "../Utils.hh"

int main()
{

  float version;
  fits_get_version(&version);
  std::cerr << "Version no." << version << std::endl;

  fitsfile *fptr;
  int status = 0;
  char *template_file = (char *)getPSRFITSdefn().c_str();
  std::cerr << "opening with template...";
//   fits_create_template(&fptr, "!test.fits", getPSRFITSdefn().c_str(),&status);
  //  fits_create_template(&fptr, "!test.fits", "simpletemplate.fits",&status);
//   fits_create_template(&fptr,"!test.fits","combinedtemplate.fits",&status);
  fits_create_template(&fptr,"!test.fits","psrheaderSimple.txt",&status);
  if(status) fits_report_error(stderr, status);
  std::cerr << "done.\n";

  std::cerr << "moving to 1st hdu...";
  status = 0;
  fits_movabs_hdu(fptr, 1, 0, &status);
  if(status) fits_report_error(stderr, status);
  std::cerr << "done.\n\n";
  std::cerr << "new keyword...";
  status=0;
  float fval = 193.23456;
  fits_update_key(fptr, TFLOAT, "STT_CRD1", &fval, NULL, &status);
  if(status) fits_report_error(stderr, status);
  std::cerr << "done.\n";

  std::cerr << "moving to subint hdu...";
  status = 0;
  fits_movnam_hdu(fptr, ANY_HDU, "subint", 0, &status);
  if(status) fits_report_error(stderr, status);
  std::cerr << "done.\n\n";
  std::cerr << "new keyword...";
  int ival = 256;
  status=0;
  fits_update_key(fptr, TINT, "NCH_FILE", &ival, NULL, &status);
  if(status) fits_report_error(stderr, status);
  std::cerr << "done.\n";

  std::cerr << "closing...";
  status = 0;
  fits_close_file(fptr, &status);
  if (status){
    fits_report_error(stderr, status);
  }
  std::cerr << "done.\n";

}
